(function () {
  (function () {
    function r(e, n, t) {
      function o(i, f) {
        if (!n[i]) {
          if (!e[i]) {
            var c = "function" == typeof require && require;
            if (!f && c) return c(i, !0);
            if (u) return u(i, !0);
            var a = new Error("Cannot find module '" + i + "'");
            throw ((a.code = "MODULE_NOT_FOUND"), a);
          }
          var p = (n[i] = { exports: {} });
          e[i][0].call(
            p.exports,
            function (r) {
              var n = e[i][1][r];
              return o(n || r);
            },
            p,
            p.exports,
            r,
            e,
            n,
            t
          );
        }
        return n[i].exports;
      }
      for (
        var u = "function" == typeof require && require, i = 0;
        i < t.length;
        i++
      )
        o(t[i]);
      return o;
    }
    return r;
  })()(
    {
      1: [
        function (require, module, exports) {
          (function (global) {
            //↓↓↓↓↓ Do not change. ↓↓↓↓↓
            function PluginObject(canvasId) {
              this.canvasId = canvasId;

              this.x = 0;
              this.y = 0;
              this.width = 0;
              this.height = 0;

              this.drillDown = null;
              this.drillUp = null;
              this.drillThrough = null;
              this.relation = null;
              this.dataPointAction = null;

              this.invalidateDisplayList = null;
              this.callLater = null;
            }

            PluginObject.prototype = {};
            PluginObject.prototype.constructor = PluginObject;
            module.exports = PluginObject;

            PluginObject.prototype.createChildren = function () {};

            PluginObject.prototype.updateDisplayList = function (
              width,
              height
            ) {};

            PluginObject.prototype.setConfig = function (config) {};

            PluginObject.prototype.setData = function (data, type) {};

            PluginObject.prototype.onMove = function (x, y) {
              this.x = x;
              this.y = y;
            };

            PluginObject.prototype.onResize = function (width, height) {
              this.width = width;
              this.height = height;
            };

            PluginObject.prototype.onMouseEvent = function (event) {};

            PluginObject.prototype.onKeyboardEvent = function (event) {};

            PluginObject.prototype.destroy = function () {};

            if (!global.JSPLUGIN) {
              global.JSPLUGIN = {};
            }
            //↑↑↑↑↑ Do not change. ↑↑↑↑↑
          }.call(
            this,
            typeof global !== "undefined"
              ? global
              : typeof self !== "undefined"
              ? self
              : typeof window !== "undefined"
              ? window
              : {}
          ));
        },
        {},
      ],
      2: [
        function (require, module, exports) {
          (function (global) {
            var PluginObject = require("./PluginObject");

            //↓↓↓↓↓ Please write your program. ↓↓↓↓↓
            /**
             * Constructor
             * @memberof FlowText
             * @method FlowText
             * @param {String} canvasId
             */
            function FlowText(canvasId) {
              PluginObject.call(this, canvasId);

              this.canvas = document.getElementById(canvasId);
              this.context = this.canvas.getContext("2d");
              this.values = [];
              this.renderStep = 0;
              this.xPos = 0;
              this.timer = null;
              this.config = {
                flowPixel: 10,
                updateSecMs: 100,
                fillStyle: "red",
                font: "20px _sans",
                textBaseline: "top",
                textPosIntervalY: 80,
              };
			  this.rowIndex = 0;
            }

            //↓↓↓↓↓ Do not change. ↓↓↓↓↓
            FlowText.prototype = Object.create(PluginObject.prototype);
            FlowText.prototype.constructor = FlowText;
            module.exports = FlowText;
            //↑↑↑↑↑ Do not change. ↑↑↑↑↑

            /**
             * Method called by MotionBoard when a plugin item's configuration string is set or changed.
             * @param {*} config
             * Settings example
             * {
             *   "flowPixel": 10,
             *   "updateSecMs": 100,
             *   "fillStyle": "red",
             *   "font": "20px _sans",
             *   "textBaseline": "top",
             *   "textPosIntervalY": 80
             * }
             * @memberof FlowText
             * @method setConfig
             */
            FlowText.prototype.setConfig = function (config) {
              if (config === null || config.length === 0) {
                return;
              }

              try {
                const cfg = JSON.parse(config);
                if ("flowPixel" in cfg) {
                  this.config.flowPixel = cfg.flowPixel;
                }
                if ("updateSecMs" in cfg) {
                  this.config.updateSecMs = cfg.updateSecMs;
                  if (this.timer !== null) {
				    clearTimeout(this.timer);
                  }
                  this.timer = setInterval(() => {
                    this.invalidateDisplayList(this);
                  }, this.config.updateSecMs);
              　　}
                if ("fillStyle" in cfg) {
                  this.config.fillStyle = cfg.fillStyle;
                }
                if ("font" in cfg) {
                  this.config.font = cfg.font;
                }
                if ("textBaseline" in cfg) {
                  this.config.textBaseline = cfg.textBaseline;
                }
                if ("textPosIntervalY" in cfg) {
                  this.config.textPosIntervalY = cfg.textPosIntervalY;
                }
                this.error_message = null;
              } catch (err) {
                this.error_message = "Invalid value" + err;
              }
            };

            /**
             * Method called by MotionBoard when data for a plug-in item is set or changed
             * @param {Dynamic} data
             * @param {String} type
             * @memberof FlowText
             * @method setData
             */
            FlowText.prototype.setData = function (data, type) {
              this.destroy();
              this.createChildren();
              this.values = this.parseFData(data);
            };

            /**
             * Method called by MotionBoard when a plug-in item is added to the stage
             * @memberof FlowText
             * @method createChildren
             */
            FlowText.prototype.createChildren = function () {
              PluginObject.prototype.createChildren.call(this);

              if (this.timer === null) {
                this.timer = setInterval(() => {
                  this.invalidateDisplayList(this);
                }, this.config.updateSecMs);
              }
            };

            /**
             * Method called by MotionBoard when a plugin item is destroyed
             * @memberof FlowText
             * @method destroy
             */
            FlowText.prototype.destroy = function () {
              PluginObject.prototype.destroy.call(this);

              if (this.timer !== null) {
                clearTimeout(this.timer);
                this.timer = null;
              }
            };

            /**
             * Method called by MotionBoard when drawing charts
             * @param {float} width
             * @param {float} height
             * @memberof FlowText
             * @method updateDisplayList
             */
            FlowText.prototype.updateDisplayList = function (width, height) {
              if (this.renderStep === 0) {
                this.xPos = width;
                this.renderStep = 1;
              }
              this.drawText(width, height);
            };

            /**
             * Character output method
             * @param {float} width
             * @param {float} height
             * @memberof FlowText
             * @method drawText
             */
            FlowText.prototype.drawText = function (width, height) {
              this.context.clearRect(0, 0, width, height);
              this.xPos -= this.config.flowPixel;
              this.context.fillStyle = this.config.fillStyle;
              this.context.font = this.config.font;
              this.context.textBaseline = this.config.textBaseline;
              if (this.xPos < 0) {
                this.xPos = width;
                this.rowIndex++;
                if(this.rowIndex >= this.values.length) {
                  this.rowIndex = 0;
                }
              }
              if(this.config.textPosIntervalY <= 0) {
                this.context.fillText(
                  this.values[this.rowIndex].text,
                  this.xPos,
                  1
                );
              } else {
                this.values.forEach((value, index) => {
                  this.context.fillText(
                    value.text,
                    this.xPos,
                    this.config.textPosIntervalY * (index + 1)
                  );
                });
			  }
            };

            /**
             * Format detail data acquired from MB into a row-by-row array
             * @param {Array} data = [[col1value, col2value...], []...]
             * @returns {Array} [{col1:value, col2:value...}, {}...]
             * @memberof FlowText
             * @method drawText
             */
            FlowText.prototype.parseFData = function (data) {
              result = [];
              for (let i = 0; i < data.dataArray.length; i++) {
                row = {};
                for (let j = 0; j < data.itemDefinitionList.length; j++) {
                  row[data.itemDefinitionList[j].name] = data.dataArray[i][j];
                }
                result.push(row);
              }
              return result;
            };

            //↑↑↑↑↑ Please write your program. ↑↑↑↑↑

            global.JSPLUGIN.FlowText = {
              _class_: FlowText,
            };
          }.call(
            this,
            typeof global !== "undefined"
              ? global
              : typeof self !== "undefined"
              ? self
              : typeof window !== "undefined"
              ? window
              : {}
          ));
        },
        { "./PluginObject": 1 },
      ],
    },
    {},
    [2]
  );
})();
